Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/BenchmarkSuitePushSolutionView.Designer.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/BenchmarkSuitePushSolutionView.Designer.cs	(revision 14897)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/BenchmarkSuitePushSolutionView.Designer.cs	(revision 14897)
@@ -0,0 +1,167 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Problem.BenchmarkSuite {
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Views;
+
+  partial class BenchmarkSuitePushSolutionView {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (this.components != null)) {
+        this.components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.tabControl = new System.Windows.Forms.TabControl();
+      this.tabPage1 = new System.Windows.Forms.TabPage();
+      this.pushDebugger = new HeuristicLab.Problems.ProgramSynthesis.Push.Views.PushDebuggerView();
+      this.exampleComboBox = new System.Windows.Forms.ComboBox();
+      this.label1 = new System.Windows.Forms.Label();
+      this.tabPage2 = new System.Windows.Forms.TabPage();
+      this.resultsDataGrid = new System.Windows.Forms.DataGridView();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
+      this.tabControl.SuspendLayout();
+      this.tabPage1.SuspendLayout();
+      this.tabPage2.SuspendLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.resultsDataGrid)).BeginInit();
+      this.SuspendLayout();
+      //
+      // nameTextBox
+      //
+      this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
+      this.errorProvider.SetIconPadding(this.nameTextBox, 2);
+      this.nameTextBox.Size = new System.Drawing.Size(755, 20);
+      //
+      // infoLabel
+      //
+      this.infoLabel.Location = new System.Drawing.Point(838, 3);
+      //
+      // tabControl
+      //
+      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.tabControl.Controls.Add(this.tabPage1);
+      this.tabControl.Controls.Add(this.tabPage2);
+      this.tabControl.Location = new System.Drawing.Point(6, 26);
+      this.tabControl.Name = "tabControl";
+      this.tabControl.SelectedIndex = 0;
+      this.tabControl.Size = new System.Drawing.Size(848, 602);
+      this.tabControl.TabIndex = 12;
+      //
+      // tabPage1
+      //
+      this.tabPage1.AutoScroll = true;
+      this.tabPage1.Controls.Add(this.pushDebugger);
+      this.tabPage1.Controls.Add(this.exampleComboBox);
+      this.tabPage1.Controls.Add(this.label1);
+      this.tabPage1.Location = new System.Drawing.Point(4, 22);
+      this.tabPage1.Name = "tabPage1";
+      this.tabPage1.Padding = new System.Windows.Forms.Padding(3);
+      this.tabPage1.Size = new System.Drawing.Size(840, 576);
+      this.tabPage1.TabIndex = 0;
+      this.tabPage1.Text = "Debug";
+      this.tabPage1.UseVisualStyleBackColor = true;
+      //
+      // pushDebugger
+      //
+      this.pushDebugger.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.pushDebugger.Caption = "View";
+      this.pushDebugger.Content = null;
+      this.pushDebugger.Location = new System.Drawing.Point(6, 33);
+      this.pushDebugger.Name = "pushDebugger";
+      this.pushDebugger.ReadOnly = false;
+      this.pushDebugger.Size = new System.Drawing.Size(831, 540);
+      this.pushDebugger.TabIndex = 12;
+      //
+      // exampleComboBox
+      //
+      this.exampleComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.exampleComboBox.FormattingEnabled = true;
+      this.exampleComboBox.Location = new System.Drawing.Point(58, 6);
+      this.exampleComboBox.Name = "exampleComboBox";
+      this.exampleComboBox.Size = new System.Drawing.Size(776, 21);
+      this.exampleComboBox.TabIndex = 11;
+      //
+      // label1
+      //
+      this.label1.AutoSize = true;
+      this.label1.Location = new System.Drawing.Point(3, 9);
+      this.label1.Name = "label1";
+      this.label1.Size = new System.Drawing.Size(50, 13);
+      this.label1.TabIndex = 10;
+      this.label1.Text = "Example:";
+      //
+      // tabPage2
+      //
+      this.tabPage2.Controls.Add(this.resultsDataGrid);
+      this.tabPage2.Location = new System.Drawing.Point(4, 22);
+      this.tabPage2.Name = "tabPage2";
+      this.tabPage2.Padding = new System.Windows.Forms.Padding(3);
+      this.tabPage2.Size = new System.Drawing.Size(840, 576);
+      this.tabPage2.TabIndex = 1;
+      this.tabPage2.Text = "Results";
+      this.tabPage2.UseVisualStyleBackColor = true;
+      //
+      // resultsDataGrid
+      //
+      this.resultsDataGrid.AllowUserToAddRows = false;
+      this.resultsDataGrid.AllowUserToDeleteRows = false;
+      this.resultsDataGrid.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.AutoSize;
+      this.resultsDataGrid.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.resultsDataGrid.EditMode = System.Windows.Forms.DataGridViewEditMode.EditProgrammatically;
+      this.resultsDataGrid.Location = new System.Drawing.Point(3, 3);
+      this.resultsDataGrid.Name = "resultsDataGrid";
+      this.resultsDataGrid.ReadOnly = true;
+      this.resultsDataGrid.Size = new System.Drawing.Size(834, 570);
+      this.resultsDataGrid.TabIndex = 0;
+      //
+      // BenchmarkSuitePushSolutionView
+      //
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.tabControl);
+      this.Name = "BenchmarkSuitePushSolutionView";
+      this.Size = new System.Drawing.Size(857, 631);
+      this.Controls.SetChildIndex(this.tabControl, 0);
+      this.Controls.SetChildIndex(this.nameLabel, 0);
+      this.Controls.SetChildIndex(this.nameTextBox, 0);
+      this.Controls.SetChildIndex(this.infoLabel, 0);
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
+      this.tabControl.ResumeLayout(false);
+      this.tabPage1.ResumeLayout(false);
+      this.tabPage1.PerformLayout();
+      this.tabPage2.ResumeLayout(false);
+      ((System.ComponentModel.ISupportInitialize)(this.resultsDataGrid)).EndInit();
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.TabControl tabControl;
+    private System.Windows.Forms.TabPage tabPage1;
+    private System.Windows.Forms.ComboBox exampleComboBox;
+    private System.Windows.Forms.Label label1;
+    private System.Windows.Forms.TabPage tabPage2;
+    private System.Windows.Forms.DataGridView resultsDataGrid;
+    private PushDebuggerView pushDebugger;
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/BenchmarkSuitePushSolutionView.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/BenchmarkSuitePushSolutionView.cs	(revision 14897)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/BenchmarkSuitePushSolutionView.cs	(revision 14897)
@@ -0,0 +1,226 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Problem.BenchmarkSuite {
+  using System;
+  using System.Globalization;
+  using System.Linq;
+  using System.Windows.Forms;
+  using Core.Views;
+  using HeuristicLab.BenchmarkSuite;
+  using HeuristicLab.BenchmarkSuite.Problems;
+  using HeuristicLab.BenchmarkSuite.Views;
+  using Interpreter;
+  using MainForm;
+  using Problem;
+  using Stack;
+
+  [View("Push Program Debugger")]
+  [Content(typeof(PushSolution), true)]
+  public partial class BenchmarkSuitePushSolutionView : NamedItemView {
+
+    private const string Separator = ", ";
+    private const string EmptySign = "-";
+
+    private const string exampleSplitter = " => ";
+    private const string AbsoluteDiffHeaderText = "Absolute Diff.";
+    private const string RelativeDiffHeaderText = "Relative Diff.";
+    private const string InputHeaderStringFormat = "Input {0} : {1}";
+    private const string EstimatedOutputHeaderStringFormat = "Estimated Output {0} : {1}";
+    private const string OutputHeaderStringFormat = "Output {0} : {1}";
+
+    private PooledPushInterpreter interpreter;
+    private PushInterpreterPool pool;
+
+    public BenchmarkSuitePushSolutionView() {
+      InitializeComponent();
+      Name = "Push Program Debugger";
+      InitEvents();
+    }
+
+    ~BenchmarkSuitePushSolutionView() {
+      this.interpreter.Dispose();
+    }
+
+    private void InitEvents() {
+      this.exampleComboBox.SelectedIndexChanged += this.SelectedExampleIndexChanged;
+      this.pushDebugger.OnReset += this.PushDebuggerReset;
+    }
+
+    private void PushDebuggerReset(object sender, IPushInterpreter interpreter) {
+      if (this.exampleComboBox.SelectedIndex < 0) return;
+
+      var example = Evaluator.Data.Examples[this.exampleComboBox.SelectedIndex];
+
+      interpreter.BooleanStack.Push(example.InputBoolean);
+      interpreter.IntegerStack.Push(example.InputInteger);
+      interpreter.FloatStack.Push(example.InputFloat);
+      interpreter.CharStack.Push(example.InputChar);
+      interpreter.StringStack.Push(example.InputString);
+      interpreter.IntegerVectorStack.Push(example.InputIntegerVector.Select(x => x.ToList()).ToArray());
+      interpreter.FloatVectorStack.Push(example.InputFloatVector.Select(x => x.ToList()).ToArray());
+      interpreter.StringVectorStack.Push(example.InputStringVector.Select(x => x.ToList()).ToArray());
+      interpreter.BooleanVectorStack.Push(example.InputBooleanVector.Select(x => x.ToList()).ToArray());
+    }
+
+    private void SelectedExampleIndexChanged(object sender, EventArgs e) {
+      this.pushDebugger.ResetDebugging();
+    }
+
+    public new PushBenchmarkSuiteSolution Content
+    {
+      get { return (PushBenchmarkSuiteSolution)base.Content; }
+      set
+      {
+        base.Content = value;
+      }
+    }
+
+    public PushBenchmarkSuiteEvaluator Evaluator
+    {
+      get { return (PushBenchmarkSuiteEvaluator)Content.Evaluator; }
+    }
+
+    protected override void OnContentChanged() {
+      if (this.Content == null) return;
+
+      this.Name = "Push Solution";
+      this.nameTextBox.Text = this.Name;
+
+      this.pool = new PushInterpreterPool(this.Content.Config);
+
+      if (this.interpreter != null) {
+        this.interpreter.Dispose();
+      }
+
+      this.interpreter = this.pool.Create(this.Content.Random);
+      this.UpdateExamples(Evaluator.Data);
+
+      if (this.exampleComboBox.SelectedIndex < 0) {
+        this.exampleComboBox.SelectedIndex = 0; // Triggers ResetDebugging via event
+      }
+
+      this.InitResultGrid();
+      this.pushDebugger.Content = this.Content;
+    }
+
+    private void InitResultGrid() {
+      this.resultsDataGrid.Columns.Clear();
+      this.resultsDataGrid.Rows.Clear();
+
+      var cellTemplate = new DataGridViewTextBoxCell();
+      var data = Evaluator.Data;
+
+      for (var i = 0; i < data.InputArgumentTypes.Length; i++) {
+        var headerTypeName = ViewHelper.GetHeaderTypeName(data.InputArgumentTypes[i]);
+        var column = new DataGridViewColumn {
+          HeaderText = string.Format(InputHeaderStringFormat, i + 1, headerTypeName),
+          AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill,
+          CellTemplate = cellTemplate
+        };
+
+        column.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
+        this.resultsDataGrid.Columns.Add(column);
+      }
+
+      for (var i = 0; i < data.OutputArgumentTypes.Length; i++) {
+        var headerTypeName = ViewHelper.GetHeaderTypeName(data.OutputArgumentTypes[i]);
+
+        var estimatedOutputColumn = new DataGridViewColumn {
+          HeaderText = string.Format(EstimatedOutputHeaderStringFormat, i + 1, headerTypeName),
+          AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill,
+          CellTemplate = cellTemplate,
+        };
+
+        var outputColumn = new DataGridViewColumn {
+          HeaderText = string.Format(OutputHeaderStringFormat, i + 1, headerTypeName),
+          AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill,
+          CellTemplate = cellTemplate
+        };
+
+        estimatedOutputColumn.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
+        outputColumn.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
+
+        this.resultsDataGrid.Columns.Add(estimatedOutputColumn);
+        this.resultsDataGrid.Columns.Add(outputColumn);
+      }
+
+      var absoluteDiffColumn = new DataGridViewColumn {
+        HeaderText = AbsoluteDiffHeaderText,
+        AutoSizeMode = DataGridViewAutoSizeColumnMode.ColumnHeader,
+        CellTemplate = cellTemplate
+      };
+
+      var relativeDiffColumn = new DataGridViewColumn {
+        HeaderText = RelativeDiffHeaderText,
+        AutoSizeMode = DataGridViewAutoSizeColumnMode.ColumnHeader,
+        CellTemplate = cellTemplate,
+      };
+
+      absoluteDiffColumn.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
+      relativeDiffColumn.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
+
+      this.resultsDataGrid.Columns.Add(absoluteDiffColumn);
+      this.resultsDataGrid.Columns.Add(relativeDiffColumn);
+
+      using (var pushInterpreter = this.pool.Create(this.Content.Random)) {
+        for (var i = 0; i < data.Examples.Length; i++) {
+          var example = data.Examples[i];
+          var row = new DataGridViewRow();
+          var absoluteDiff = Evaluator.Evaluate(pushInterpreter, Content.Program, i);
+          var relativeDiff = absoluteDiff / Math.Abs(data.BestResult - data.WorstResult) * 100d;
+
+          row.HeaderCell.Value = row.Index + 1;
+          row.CreateCells(this.resultsDataGrid);
+
+          for (var j = 0; j < data.InputArgumentTypes.Length; j++) {
+            row.Cells[j].Value = ViewHelper.StringifyInput(data.InputArgumentTypes[j], example, Separator);
+          }
+
+          for (var j = 0; j < data.OutputArgumentTypes.Length; j++) {
+            row.Cells[data.InputArgumentTypes.Length + j * 2].Value = ViewHelper.StringifyOutput(data.OutputArgumentTypes[j], example, Separator);
+            row.Cells[data.InputArgumentTypes.Length + j * 2 + 1].Value = this.StringifyResult(data.OutputArgumentTypes[j], pushInterpreter, example, Separator);
+          }
+
+          row.Cells[data.TotalArgumentCount + 1].Value = absoluteDiff;
+          row.Cells[data.TotalArgumentCount + 2].Value = relativeDiff + "%";
+
+          this.resultsDataGrid.Rows.Add(row);
+          pushInterpreter.Reset();
+        }
+      }
+    }
+
+    private string StringifyResult(ExampleArgumentType type, IPushInterpreter interpreter, Example example, string valueSeparator) {
+      switch (type) {
+        case ExampleArgumentType.Integer:
+        case ExampleArgumentType.IntegerVector: return interpreter.IntegerStack.IsEmpty ? EmptySign : string.Join(valueSeparator, interpreter.IntegerStack.Peek(this.GetCount(interpreter.IntegerStack, example.OutputInteger)));
+
+        case ExampleArgumentType.Float:
+        case ExampleArgumentType.FloatVector: return interpreter.FloatStack.IsEmpty ? EmptySign : string.Join(valueSeparator, interpreter.FloatStack.Peek(this.GetCount(interpreter.FloatStack, example.OutputFloat)).Select(d => d.ToString(CultureInfo.CurrentUICulture)));
+
+        case ExampleArgumentType.Boolean: return interpreter.BooleanStack.IsEmpty ? EmptySign : interpreter.BooleanStack.Top.ToString();
+        case ExampleArgumentType.Char: return interpreter.CharStack.IsEmpty ? EmptySign : interpreter.CharStack.Top.ToString();
+
+        case ExampleArgumentType.String:
+        case ExampleArgumentType.StringVector: return interpreter.StringStack.IsEmpty ? EmptySign : string.Join(valueSeparator, interpreter.StringStack.Peek(this.GetCount(interpreter.StringStack, example.OutputString)));
+        default: return string.Empty;
+      }
+    }
+
+    private int GetCount<T>(IPushStack<T> stack, T[] data) {
+      return Math.Max(0, Math.Min(data.Length, stack.Count));
+    }
+
+    private void UpdateExamples(ProblemData data) {
+      this.exampleComboBox.Items.Clear();
+      if (data == null) return;
+
+      var stringRepresentations = data.Examples.Select(e =>
+        string.Join(Separator, e.InputArgs) +
+        exampleSplitter +
+        string.Join(Separator, e.OutputArgs));
+
+      foreach (var str in stringRepresentations) {
+        this.exampleComboBox.Items.Add(str);
+      }
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteEvaluator.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteEvaluator.cs	(revision 14897)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteEvaluator.cs	(revision 14897)
@@ -0,0 +1,294 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Problem.BenchmarkSuite {
+  using System;
+  using System.Collections.Generic;
+  using Common;
+  using Core;
+  using Expressions;
+  using HeuristicLab.BenchmarkSuite.Problems;
+  using HeuristicLab.Parameters;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+
+  using Interpreter;
+  using Problem;
+  using Stack;
+
+  [StorableClass]
+  public class PushBenchmarkSuiteEvaluator : ParameterizedNamedItem, IPushEvaluator {
+
+    private const string DataBoundsParameterName = "DataBounds";
+    private const string DataParameterName = "Data";
+    private const string DataParameterDescription = "Program Synthesis";
+
+    public PushBenchmarkSuiteEvaluator() {
+      Parameters.Add(new FixedValueParameter<DataBounds>(DataBoundsParameterName));
+
+      Parameters.Add(new ValueParameter<ProblemData>(
+        DataParameterName,
+        DataParameterDescription));
+    }
+
+    public PushBenchmarkSuiteEvaluator(ProblemData data) : this() {
+      LoadData(data);
+    }
+
+    [StorableConstructor]
+    public PushBenchmarkSuiteEvaluator(bool deserializing) { }
+
+    public PushBenchmarkSuiteEvaluator(PushBenchmarkSuiteEvaluator origin, Cloner cloner) : base(origin, cloner) {
+      Data = cloner.Clone(origin.Data);
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PushBenchmarkSuiteEvaluator(this, cloner);
+    }
+
+    public IValueParameter<ProblemData> DataParameter
+    {
+      get { return (IValueParameter<ProblemData>)Parameters[DataParameterName]; }
+    }
+
+    public ProblemData Data
+    {
+      get { return DataParameter.Value; }
+      set { DataParameter.Value = value; }
+    }
+
+    public IValueParameter<DataBounds> DataBoundsParameter
+    {
+      get { return (IValueParameter<DataBounds>)Parameters[DataBoundsParameterName]; }
+    }
+
+    public DataBounds DataBounds
+    {
+      get { return DataBoundsParameter.Value; }
+      set { DataBoundsParameter.Value = value; }
+    }
+
+    public void LoadData(ProblemData data) {
+      this.Data = data;
+
+      DataBounds.TrainingRange.Start = 0;
+      DataBounds.TrainingRange.End = Data.TrainingCount;
+      DataBounds.TestRange.Start = Data.TrainingCount;
+      DataBounds.TestRange.End = Data.TrainingCount + Data.TestCount;
+    }
+
+    public EvaluationResult Evaluate(IPushInterpreter interpreter, PushProgram program, IRandom random, int start, int end) {
+      var length = end - start;
+      if (length <= 0) return null;
+
+      var evaluationResult = new EvaluationResult(length);
+
+      for (var i = start; i < end; i++) {
+        var result = Evaluate(interpreter, program, i);
+        evaluationResult.ExampleQualities[i - start] = result;
+        evaluationResult.TotalQuality += result;
+        interpreter.Reset();
+      }
+
+      evaluationResult.TotalQuality /= length;
+
+      return evaluationResult;
+    }
+
+    public EvaluationResult EvaluateTest(IPushInterpreter interpreter, PushProgram program, IRandom random) {
+      return Evaluate(interpreter, program, random, DataBounds.TestRange.Start, DataBounds.TestRange.End);
+    }
+
+    public EvaluationResult EvaluateTest(IReadOnlyPushConfiguration config, PushProgram program, IRandom random) {
+      var interpreter = new PushInterpreter(config, random);
+      return EvaluateTest(interpreter, program, random);
+    }
+
+    public EvaluationResult EvaluateTest(PushInterpreterPool pool, PushProgram program, IRandom random) {
+      using (var interpreter = pool.Create(random)) {
+        return EvaluateTest(interpreter, program, random);
+      }
+    }
+
+    public EvaluationResult EvaluateTraining(IPushInterpreter interpreter, PushProgram program, IRandom random) {
+      return Evaluate(interpreter, program, random, DataBounds.TrainingRange.Start, DataBounds.TrainingRange.End);
+    }
+
+    public EvaluationResult EvaluateTraining(IReadOnlyPushConfiguration config, PushProgram program, IRandom random) {
+      var interpreter = new PushInterpreter(config, random);
+      return EvaluateTraining(interpreter, program, random);
+    }
+
+    public EvaluationResult EvaluateTraining(PushInterpreterPool pool, PushProgram program, IRandom random) {
+      using (var interpreter = pool.Create(random)) {
+        return EvaluateTraining(interpreter, program, random);
+      }
+    }
+
+    public double Evaluate(IPushInterpreter interpreter, PushProgram program, int exampleIndex) {
+      var example = Data.Examples[exampleIndex];
+
+      interpreter.BooleanStack.Push(example.InputBoolean);
+      interpreter.IntegerStack.Push(example.InputInteger);
+      interpreter.FloatStack.Push(example.InputFloat);
+
+      interpreter.Run(program);
+
+      var result = GetDiff(example.OutputInteger, interpreter.IntegerStack, Data.WorstResult, IntegerDiffer)
+                 + GetDiff(example.OutputFloat, interpreter.FloatStack, Data.WorstResult, FloatDiffer)
+                 + GetDiff(example.OutputBoolean, interpreter.BooleanStack, Data.WorstResult, BooleanDiffer)
+                 + GetDiff(example.OutputString, interpreter.StringStack, Data.WorstResult, StringDiffer)
+                 + GetDiff(example.OutputChar, interpreter.CharStack, Data.WorstResult, CharDiffer)
+                 + GetPrintDiffer(example.OutputPrint, interpreter.PrintStack)
+                 + GetVectorDiff(example.OutputIntegerVector, interpreter.IntegerVectorStack, Data.WorstResult, (a, b) => VectorDiffer(a, b, IntegerDiffer))
+                 + GetVectorDiff(example.OutputFloatVector, interpreter.FloatVectorStack, Data.WorstResult, (a, b) => VectorDiffer(a, b, FloatDiffer))
+                 + GetVectorDiff(example.OutputStringVector, interpreter.StringVectorStack, Data.WorstResult, (a, b) => VectorDiffer(a, b, StringDiffer));
+
+      return result;
+    }
+
+    private static double FloatDiffer(double a, double b) {
+      var result = a - b;
+
+      if (result.IsAlmost(double.MinValue) || double.IsPositiveInfinity(result) || double.IsNaN(result))
+        return double.MaxValue;
+
+      if (result.IsAlmost(double.MaxValue) || double.IsNegativeInfinity(result))
+        return double.MinValue;
+
+      return Math.Abs(result);
+    }
+
+    private static double IntegerDiffer(long a, long b) {
+      var result = a - b;
+
+      return result == long.MinValue ? long.MaxValue : Math.Abs(result);
+    }
+
+    private static double BooleanDiffer(bool a, bool b) {
+      return a && b ? 0 : a || b ? 1 : 2;
+    }
+
+    private static double StringDiffer(string a, string b) {
+      return LevenshteinDistance(a, b);
+    }
+
+    private static double CharDiffer(char a, char b) {
+      return IntegerDiffer(a, b);
+    }
+
+    private static double VectorDiffer<T>(IReadOnlyList<T> estimated, IReadOnlyList<T> outcome, Func<T, T, double> differ) {
+      var length = Math.Min(estimated.Count, outcome.Count);
+      var result = 0d;
+
+      for (var i = 0; i < length; i++) {
+        result += differ(estimated[i], outcome[i]);
+      }
+
+      if (estimated.Count > outcome.Count) {
+        var remainingLength = estimated.Count - length;
+        for (var i = 0; i < remainingLength; i++)
+          result += differ(estimated[i], default(T));
+      }
+
+      return result;
+    }
+
+    private static double GetPrintDiffer(string estimated, IPushStack<string> printStack) {
+      var printResult = string.Join(Environment.NewLine, printStack);
+
+      return LevenshteinDistance(estimated, printResult);
+    }
+
+    private static double GetVectorDiff<T>(IReadOnlyList<IReadOnlyList<T>> estimated, IPushStack<List<T>> resultStack, double worstResult, Func<IReadOnlyList<T>, IReadOnlyList<T>, double> differ)
+      where T : IComparable {
+      if (estimated.Count == 0) return 0d;
+
+      var diff = 0d;
+      var comparableLength = 0;
+
+      if (!resultStack.IsEmpty) {
+        var count = Math.Min(estimated.Count, resultStack.Count);
+        var result = resultStack.Peek(count);
+        comparableLength = Math.Min(estimated.Count, result.Length);
+
+        for (var i = 0; i < comparableLength; i++) {
+          diff += Math.Min(differ(estimated[i], result[i]), worstResult);
+        }
+      }
+
+      var emptyTArray = new T[0];
+      for (var i = comparableLength; i < estimated.Count - comparableLength; i++) {
+        diff += differ(estimated[i], emptyTArray);
+      }
+
+      return diff;
+    }
+
+    private static double GetDiff<T>(IReadOnlyList<T> estimated, IPushStack<T> resultStack, double worstResult, Func<T, T, double> differ)
+      where T : IComparable {
+      if (estimated.Count == 0) return 0d;
+
+      var diff = 0d;
+      var comparableLength = 0;
+
+      if (!resultStack.IsEmpty) {
+        var count = Math.Min(estimated.Count, resultStack.Count);
+        var result = resultStack.Peek(count);
+        comparableLength = Math.Min(estimated.Count, result.Length);
+
+        for (var i = 0; i < comparableLength; i++) {
+          diff += Math.Min(differ(estimated[i], result[i]), worstResult);
+        }
+      }
+
+      for (var i = comparableLength; i < estimated.Count - comparableLength; i++) {
+        diff += differ(estimated[i], default(T));
+      }
+
+      return diff;
+    }
+
+    /// <summary>
+    /// https://www.dotnetperls.com/levenshtein
+    /// </summary>
+    private static int LevenshteinDistance(string source, string target) {
+      if (source == null && target == null) return 0;
+      if (source == null) return target.Length;
+      if (target == null) return source.Length;
+
+      int n = source.Length;
+      int m = target.Length;
+      int[,] d = new int[n + 1, m + 1];
+
+      // Step 1
+      if (n == 0) {
+        return m;
+      }
+
+      if (m == 0) {
+        return n;
+      }
+
+      // Step 2
+      for (int i = 0; i <= n; d[i, 0] = i++) {
+      }
+
+      for (int j = 0; j <= m; d[0, j] = j++) {
+      }
+
+      // Step 3
+      for (int i = 1; i <= n; i++) {
+        //Step 4
+        for (int j = 1; j <= m; j++) {
+          // Step 5
+          int cost = (target[j - 1] == source[i - 1]) ? 0 : 1;
+
+          // Step 6
+          d[i, j] = Math.Min(
+              Math.Min(d[i - 1, j] + 1, d[i, j - 1] + 1),
+              d[i - 1, j - 1] + cost);
+        }
+      }
+      // Step 7
+      return d[n, m];
+    }
+  }
+}
